<?php

/**
 * This software is intended for use with Oxwall Free Community Software http://www.oxwall.org/ and is a proprietary licensed product. 
 * For more information see License.txt in the plugin folder.

 * ---
 * Copyright (c) 2018, Ebenezer Obasi
 * All rights reserved.
 * info@eobasi.com.

 * Redistribution and use in source and binary forms, with or without modification, are not permitted provided.

 * This plugin should be bought from the developer. For details contact info@eobasi.com.

 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
 * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

/**
 * Data Access Object for `helpcenter_category` table.
 *
 * @author Ebenezer Obasi <info@eobasi.com>
 * @package ow_plugins.helpcenter.bol
 * @since 1.0
 */
class HELPCENTER_BOL_CategoryDao extends OW_BaseDao
{
    /**
     * Singleton instance.
     *
     * @var HELPCENTER_BOL_CategoryDao
     */
    private static $classInstance;

    /**
     * Returns an instance of class (singleton pattern implementation).
     *
     * @return HELPCENTER_BOL_CategoryDao
     */
	public static function getInstance()
	{
		if( self::$classInstance === null )
		{
			self::$classInstance = new self();
		}

		return self::$classInstance;
	}

    /**
     * Constructor.
     */
    protected function __construct()
    {
        parent::__construct();
    }

    /**
     * @see OW_BaseDao::getDtoClassName()
     *
     */
	public function getDtoClassName()
	{
		return 'HELPCENTER_BOL_Category';
	}

    /**
     * @see OW_BaseDao::getTableName()
     *
     */
	public function getTableName()
	{
		return OW_DB_PREFIX . 'helpcenter_category';
	}
	
    /**
     * Returns all categories without parent
     *
     * @return array
     */
	public function parentCategories()
	{
		$example = new OW_Example();
		$example->andFieldEqual('parent', '0');
		
		return $this->findListByExample( $example );
	}
	
    /**
     * Returns category by categoryId
     *
     * @param integer $categoryId
     * @return array
     */
	public function categoryChildren( $categoryId )
	{
		$example = new OW_Example();
		$example->andFieldEqual('parent', $categoryId);
		
		return $this->findListByExample( $example );
	}
}