<?php

/**
 * This software is intended for use with Oxwall Free Community Software http://www.oxwall.org/ and is a proprietary licensed product. 
 * For more information see License.txt in the plugin folder.

 * ---
 * Copyright (c) 2018, Ebenezer Obasi
 * All rights reserved.
 * info@eobasi.com.

 * Redistribution and use in source and binary forms, with or without modification, are not permitted provided.

 * This plugin should be bought from the developer. For details contact info@eobasi.com.

 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
 * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

/**
 * @author Ebenezer Obasi <info@eobasi.com>
 * @package ow_plugins.helpcenter.components
 * @since 1.0
 */
class HELPCENTER_CMP_Sidebar extends OW_Component
{
	public function __construct( $categoryId = null  )
	{
		parent::__construct();

		$this->service = HELPCENTER_BOL_Service::getInstance();
		$categories = $this->service->findAllCategory( true );

		if( empty( $categories ) )
		{
			$this->setVisibility(false);
			return;
		}
		
		$cat = $this->service->findCategory( $categoryId, true );
		
		if( !empty( $cat->section ) )
		{
			$parentId = $cat->section->getId();
			
			if( !empty( $cat->grandParent ) && (int)$cat->grandParent->parent == 0 )
			{
				$parentId = $cat->grandParent->getId();
			}
			
			$this->assign('parentId', $parentId);
		}

		foreach($categories as $category)
		{
			$category->url = OW::getRouter()->urlForRoute('helpcenter_view_board', array('catId' => $category->getId( )));
			$category->active = ((int)$category->getId() == $categoryId) ? 'active' : '';

			foreach($category->children as $child)
			{
				if( $this->service->isGrandChild( $categoryId ) && (int)$cat->getParent() == $child->getId() )
				{
					$child->active = 'active';
					$child->show = !empty($child->children) ? 'show' : '';
				}
				else
				{
					$child->active = ((int)$child->getId() == $categoryId) ? 'active' : '';
					$child->show = (int)$child->getId() == $categoryId && !empty($child->children) ? 'show' : '';
				}

				$child->url = OW::getRouter()->urlForRoute('helpcenter_view_board', array('catId' => $child->getId( )));

				foreach($child->children as $granChild)
				{
					$granChild->active = (int)$granChild->getId() == $categoryId ? 'active' : '';
					$granChild->url = OW::getRouter()->urlForRoute('helpcenter_view_board', array('catId' => $granChild->getId( )));
				}
			}
		}

		$this->assign('categories', $categories);
		$this->assign('categoryId', $categoryId);
	}
}